Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time.field
Class BaseDurationField

    java.lang.Object
      org.joda.time.DurationField
          org.joda.time.field.BaseDurationField

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable

Direct Known Subclasses:
  DecoratedDurationField, PreciseDurationField

    public abstract class BaseDurationField

extends DurationField
implements java.io.Serializable

BaseDurationField provides the common behaviour for DurationField implementations.

This class should generally not be used directly by API users. The DurationField class should be used when different kinds of DurationField objects are to be referenced.

BaseDurationField is thread-safe and immutable, and its subclasses must be as well.

Since:
  1.0
Author:
  Brian S O'Neill
See Also:
  `DecoratedDurationField`, Serialized Form

Constructor Summary
`protected` | `BaseDurationField(DurationFieldType type)`

Method Summary
`int` | `compareTo(java.lang.Object durationField)` Compares this duration field with another duration field for ascending unit millisecond order.
`int` | `getDifference(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`long` | `getMillis(int value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`long` | `getMillis(long value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`java.lang.String` | `getName()` Get the name of the field.
`DurationFieldType` | `getType()` Get the type of the field.
`int` | `getValue(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`int` | `getValue(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`long` | `getValueAsLong(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`boolean` | `isSupported()` Returns true if this field is supported.
`java.lang.String` | `toString()` Get a suitable debug string.

Methods inherited from class org.joda.time.DurationField
`add, add, getDifferenceAsLong, getMillis, getMillis, getUnitMillis, getValueAsLong, isPrecise, subtract, subtract`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BaseDurationField

    protected BaseDurationField(DurationFieldType type)

Method Detail

### getType

    public final DurationFieldType getType()

  Description copied from class: `DurationField`
  Get the type of the field.

  Specified by:
    `getType` in class `DurationField`
  Returns:
    field type

### getName

    public final java.lang.String getName()

  Description copied from class: `DurationField`
  Get the name of the field.

  By convention, names are plural.

  Specified by:
    `getName` in class `DurationField`
  Returns:
    field name

### isSupported

    public final boolean isSupported()

  Description copied from class: `DurationField`
  Returns true if this field is supported.

  Specified by:
    `isSupported` in class `DurationField`
  Returns:
    true always

### getValue

    public int getValue(long duration)

  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Specified by:
    `getValue` in class `DurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValueAsLong

    public long getValueAsLong(long duration)

  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Specified by:
    `getValueAsLong` in class `DurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValue

    public int getValue(long duration,
                        long instant)

  Get the value of this field from the milliseconds relative to an instant.

  If the milliseconds is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  The default implementation returns `Utils.safeToInt(getAsLong(millisDuration, instant))`.

  Specified by:
    `getValue` in class `DurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative

### getMillis

    public long getMillis(int value)

  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Specified by:
    `getMillis` in class `DurationField`
  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getMillis

    public long getMillis(long value)

  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Specified by:
    `getMillis` in class `DurationField`
  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getDifference

    public int getDifference(long minuendInstant,
                             long subtrahendInstant)

  Description copied from class: `DurationField`
  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       int v = ...
       int age = getDifference(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Specified by:
    `getDifference` in class `DurationField`
  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### compareTo

    public int compareTo(java.lang.Object durationField)

  Description copied from class: `DurationField`
  Compares this duration field with another duration field for ascending unit millisecond order. This ordering is inconsistent with equals, as it ignores name and precision.

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Specified by:
    `compareTo` in class `DurationField`
  Parameters:
    `durationField` - a duration field to check against
  Returns:
    negative value if this is less, 0 if equal, or positive value if greater

### toString

    public java.lang.String toString()

  Get a suitable debug string.

  Specified by:
    `toString` in class `DurationField`
  Returns:
    debug string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD